Select a vertex, an edge and a face with mouse (OpenCASCADE)

863 Views Asked by At

I want to have vertex, edge, face or full body selection on AIS_Shape according to selection mode. Actually, if the vertex that I want to go from is selected, I need to obtain the coordinates of the vertex. If edge is selected I need to calculate the length. Surface area even if face is selected...

I can highlight with my command.

myViewerWidget->getContext()->Activate(TopAbs_FACE, Standard_True);

But when the shape is clicked it returns me all of its vertices or surfaces.

My code in the mouse click event is as follows;

if (theEvent->button() == Qt::LeftButton) {
    qDebug() << "Left click pressed.";

    if(!myContext->DetectedOwner().IsNull()){
        Handle(AIS_InteractiveObject) picked;
        myContext->InitSelected();
        picked = myContext->DetectedInteractive();
        Handle(AIS_Shape) aShape=Handle(AIS_Shape)::DownCast(picked);

        TopoDS_Shape topShape = aShape->Shape();

        // Vertex
        for(TopExp_Explorer vertEx(topShape, TopAbs_VERTEX); vertEx.More(); vertEx.Next()) {
            TopoDS_Vertex aVertex = TopoDS::Vertex(vertEx.Current());
            gp_Pnt aPnt = BRep_Tool::Pnt(aVertex);
            qDebug() << "Vertex: " << aPnt.X() << " " << aPnt.Y() << " " << aPnt.Z();
        }

        // Face
        for(TopExp_Explorer vertEx(topShape, TopAbs_FACE); vertEx.More(); vertEx.Next()) {
            TopoDS_Face aVertex = TopoDS::Face(vertEx.Current());
            GProp_GProps System;
            BRepGProp::SurfaceProperties(aVertex, System);
            Standard_Real Area = System.Mass();
            qDebug() << "Area: " << Area;
        }
    }

}

How can I have only one corner or edge of any AIS_Shape that I want? What am I missing?

1

There are 1 best solutions below

0
On

you should implement a mouse event

::onLeftButtonUp()

in which you retrieve the current x,y position of the cursor (mouse tracking should be enabled). Then you should use:

myContext->moveTo(x, y, ...);

[see documentation for this call]

Then retrieve the owner of your selection:

const Handle(SelectMgr_EntityOwner) &anOwnerOfDetection = myContext->DetectedOwner();

Then

//! downcast to a BRepOwner
const Handle(StdSelect_BRepOwner) &aBRepOwnerOfSelection  = Handle(StdSelect_BRepOwner)::DownCast(anOwnerOfSelection);

//! retrieve the shape of the owner
const TopoDS_Shape &selectedShape = aBRepOwnerOfDetection->Shape();

const TopoDS_Shape &shape = detectedShape.Located(aBRepOwnerOfDetection->Location() * detectedShape.Location());

OK: shape (last call) is what you have picked: if you activated selection mode for faces, the shape is a TopoDS_Face. If you activated the selection mode for vertexes, your shape is a vertex.

At the end (suppose we are dealing with vertex selection)

//! retrieve geometry
const gp_Pnt& P = BRep_Tool::Pnt(TopoDS::Vertex(shape));

// plot coordinates
cout<<"____("<<P.X()<<", "<<P.Y()<<", "<<P.Z()<<"____"<<endl;

Hope this helps Giovanni